#include"dottle.hpp"




namespace{


enum{
  ST_fw = 1,
  ST_bw = 2,
};


struct
Data
{
  List::const_iterator  it;

  Frame  frame;

};


std::vector<Data>
table;


const int
base_table[] = {-1,24,16,12,8,4};


int   base = -1;
int  count     ;


bool  isbw;


int
cur;


Label*
label;


void
draw_single(Area&  area)
{
//  area.fill(Paint::table[brush::palette[0]].base_color);

    if(table.empty())
    {
      return;
    }


  auto&         cv = *table[cur].it;
  const auto&  frm =  table[cur].frame;

    rep(y,frm.get_h()){
    rep(x,frm.get_w()){
      area.draw_dot(x,y,cv.get_pixel(frm.get_x_min()+x,frm.get_y_min()+y).get_lighted_color());
    }}
}


void
push(Button&  btn)
{
  auto  frm = get_active_frame();

    if(!frm)
    {
      frm.reset(0,0,Paper::size,Paper::size);
    }


  table.emplace_back(Data{canvas_current,frm});

  label->printf("%2d",table.size());
}


void
pop(Button&  btn)
{
    if(table.size())
    {
      table.pop_back();

      cur = 0;

      label->printf("%2d",table.size());
    }
}


void
clear(Button&  btn)
{
  table.clear();

  cur = 0;

  label->printf("%2d",table.size());
}


void
change(Counter&  cntr, int  newval, int  oldval)
{
  base = base_table[newval];
}


Counter*
cntr;


Area*  s_area;
//Area*  d_area;


CheckBox*
chkbox;


void
update(void*  ptr)
{
    if((base < 0) || (table.size() < 2))
    {
      return;
    }


    if(count)
    {
      --count;
    }


    if(!count)
    {
      count = base;

      s_area->fill();
//      d_area->fill();

      s_area->request_redraw();
//      d_area->push_draw();

        if(!isbw)
        {
            if(chkbox->get_state()&ST_fw)
            {
                if(cur < (table.size()-1))
                {
                  ++cur;
                }

              else
                if(chkbox->get_state()&ST_bw)
                {
                  --cur;

                  isbw = true;
                }

              else
                {
                  cur = 0;
                }
            }

          else
            if(chkbox->get_state()&ST_bw)
            {
              cur = (table.size()-1);

              isbw = true;
            }
        }

      else
        {
            if(chkbox->get_state()&ST_bw)
            {
                if(cur)
                {
                  --cur;
                }

              else
                if(chkbox->get_state()&ST_fw)
                {
                  ++cur;

                  isbw = false;
                }

              else
                {
                  cur = (table.size()-1);
                }
            }

          else
            if(chkbox->get_state()&ST_fw)
            {
              cur = 0;

              isbw = false;
            }
        }


    }
}


}




void
clear_anim()
{
  clear(*(Button*)0);
}


void
append_anim(Root&  win)
{
//  set_user_callback(update);

  auto  psh_btn = new Button(u"Push ");
  auto  pop_btn = new Button(u"Pop  ");
  auto  clr_btn = new Button(u"Clear");

  chkbox = new CheckBox({Icon(u"前方"),Icon(u"後方")},ST_fw);

  label = new Label(u" 0");

  cntr = new Counter(0,5);

  s_area = new Area(Paper::size  ,Paper::size  );

  s_area->set_draw_callback(draw_single);

  psh_btn->set_callback(push);
  pop_btn->set_callback(pop);
  clr_btn->set_callback(clear);

  cntr->set_callback(change);

  int  x = 480;
  int  y = 300;

  win.insert(psh_btn,x,y);  y += 24;
  win.insert(pop_btn,x,y);  y += 24;
  win.insert(clr_btn,x,y);  y += 24;

  win.insert(chkbox,x,y);  y += 48;

  win.insert(label,x,y);

  x +=  80;
  y  = 300;

  win.insert(s_area,x,y);

  y += Paper::size+24;

  win.insert(cntr,x-48,y);
}




