#ifndef _DOTTLE_
#define _DOTTLE_


#include"palette.hpp"
#include"paper.hpp"
#include"brush.hpp"
#include"frame.hpp"
#include"view.hpp"




enum
PaintMode
{
  PAI_draw_point  = 0x01,
  PAI_draw_line   = 0x02,
  PAI_draw_circle = 0x04,
  PAI_draw_rect   = 0x08,
  PAI_fill_rect   = 0x10,
  PAI_fill_area   = 0x20,
  PAI_put_copy    = 0x40,
  PAI_set_frame   = 0x80,

};


Widget*  create_paint_mode_widget();

PaintMode  get_paint_mode(               );
void       set_paint_mode(PaintMode  mode);




void  load(const std::string&  s);

const Chunk&  get_copy_chunk();

Widget*  create_io_widget();
Widget*  create_undo_widget();
Widget*  create_copy_widget();
Widget*  create_grid_widget();

bool  test_grid_using();

Widget*   create_mirror_widget();
Widget*  create_reverse_widget();
Widget*  create_revolve_widget();
Widget*  create_lrshift_widget();
Widget*  create_udshift_widget();




extern View        view;
extern Brush      brush;
extern Frame      frame;
extern Palette  palette;
extern Paper      paper;

Widget*  create_united_widget();




#endif




