#include"dottle.hpp"




namespace{


TextBox*
filename_txtbox;


bool
grid_using;


Chunk
chunk;


void
undo(Button&  btn)
{
    if(btn->test_pressing())
    {
      paper.undo();

      view.widgets.update();
    }
}


void
copy(Button&  btn)
{
    if(btn->test_pressed())
    {
      auto  rect = make_rect(frame.get_two_points());

      chunk = paper.make_chunk(rect);
    }
}


void
grid(Button&  btn)
{
  grid_using = btn->test_pressing();

  view.widgets.update();
}


void
save(Button&  btn)
{
    if(btn->test_unpressed())
    {
      auto  s = filename_txtbox->get();

        if(s.size())
        {
          const char*  ext = ".dottle";

            if(s.rfind(ext) == std::string::npos)
            {
              s += ext;
            }


          paper.save(s.data(),palette);
        }
    }
}


void
save_as_png(Button&  btn)
{
    if(btn->test_unpressed())
    {
      auto  s = filename_txtbox->get();

        if(s.size())
        {
          const char*  ext = ".png";

            if(s.rfind(ext) == std::string::npos)
            {
              s += ext;
            }


          paper.save_as_png(s.data(),palette);
        }
    }
}


}




const Chunk&
get_copy_chunk()
{
  return chunk;
}



Widget*
create_io_widget()
{
  auto  nd = new TableColumn;

  auto  l_btn = new RotorButton(u"save");
  auto  r_btn = new RotorButton(u"sava as PNG");


  filename_txtbox = new TextBox("",32);

  l_btn->set_callback(save);
  r_btn->set_callback(save_as_png);

  nd->insert(filename_txtbox);
  nd->insert(l_btn);
  nd->insert(r_btn);

  return nd;
}


Widget*
create_undo_widget()
{
  auto  btn = new Button(u"アンドゥ");

  btn->set_callback(undo,true);

  return btn;
}


Widget*
create_grid_widget()
{
  auto  btn = new Button(u"グリッド");

  btn->set_callback(grid);
  btn->set_toggle();

  return btn;
}


Widget*
create_copy_widget()
{
  auto  btn = new RotorButton(u"コピー");

  btn->set_callback(copy);

  return btn;
}


bool
test_grid_using()
{
  return grid_using;
}


void
load(const std::string&  s)
{
    if(s.size())
    {
        if(paper.load(s.data(),palette))
        {
          auto  pos = s.rfind(dirsepch);

            if(pos != std::string::npos)
            {
              filename_txtbox->set(std::string(s,pos+1));
            }

          else
            {
              filename_txtbox->set(s);
            }
        }


      view.widgets.update();
    }
}




