#ifndef _PALETTE_
#define _PALETTE_


#include"jiscolor.hpp"
#include"pixel.hpp"




class
Palette
{
public:
  enum{color_index_number = 16};

private:
  int  left_index;

  int  right_index_base;
  int  right_index_offset;

  int  light_index;

  int  color_index_table[color_index_number];


public:
  Palette();

  int   get_light_index(      ) const;
  void  set_light_index(int  i)      ;

  int   get_right_index() const;

  int   get_right_index_base(      ) const;
  void  set_right_index_base(int  i)      ;

  int   get_right_index_offset(      ) const;
  void  set_right_index_offset(int  i)      ;

  int   get_left_index(      ) const;
  void  set_left_index(int  i)      ;

  int&  get_color_index(      ){return color_index_table[left_index];}
  int&  get_color_index(int  i){return color_index_table[         i];}

  void  set_color_index(int  i, int  ci){color_index_table[i] = ci;}

  const int&  get_color_index(      ) const{return color_index_table[left_index];}
  const int&  get_color_index(int  i) const{return color_index_table[         i];}

  JisColor&  get_jiscolor(      ){return colors[get_color_index()];}
  JisColor&  get_jiscolor(int  i){return colors[                i];}

  JisColor&  get_jiscolor_for_fill(){return colors[color_index_table[0]];}

  JisColor&  get_index_color(int  i){return colors[color_index_table[i]];}
  const JisColor&  get_index_color(int  i) const{return colors[color_index_table[i]];}

  Pixel  make_pixel() const;

  std::vector<JisColor>  colors;

  void  reset_colors();


  struct Widgets{
    Area*   left_area;
    Area*  right_area;
    Area*  light_area;

    Counter*  counter;

    Node*  node;

    void  initialize();

  } widgets;

};


#endif




