#include"paper.hpp"
#include"dottle.hpp"
#include<algorithm>




Paper::
Paper()
{
}




Pixel
Paper::
get(int  x, int  y) const
{
  return pixels[y][x];
}


void
Paper::
put(int  x, int  y, const Pixel&  pixel)
{
  auto&  dst = pixels[y][x];

    if(dst != pixel)
    {
      dots.emplace_back(x,y,dst.data);

      dst = pixel;
    }
}


void
Paper::
put(int  x, int  y, const Chunk&  chunk)
{
  const int  w = (((x+chunk.get_w()) < size)? chunk.get_w():(size-x));
  const int  h = (((y+chunk.get_h()) < size)? chunk.get_h():(size-y));

    rep(yy,h){
    rep(xx,w){
      put(x+xx,y+yy,chunk.get(xx,yy));
    }}
}


void
Paper::
put_provisionally(int  x, int  y, const Pixel&  pixel)
{
  auto&  dst = pixels[y][x];

    if(dst != pixel)
    {
      backup_dots.emplace_back(x,y,dst.data);

      dst = pixel;
    }
}


void
Paper::
put_provisionally(int  x, int  y, const Chunk&  chunk)
{
  const int  w = (((x+chunk.get_w()) < size)? chunk.get_w():(size-x));
  const int  h = (((y+chunk.get_h()) < size)? chunk.get_h():(size-y));

    rep(yy,h){
    rep(xx,w){
      put_provisionally(x+xx,y+yy,chunk.get(xx,yy));
    }}
}


void
Paper::
restore_backups()
{
    for(auto&  dot: backup_dots)
    {
      auto      x = dot.get_x();
      auto      y = dot.get_y();
      auto  pixel = dot.get_pixel();

      pixels[y][x] = pixel;
    }


  backup_dots.clear();
}


void
Paper::
apply_backups()
{
    for(auto&  dot: backup_dots)
    {
      dots.push_back(dot);
    }


  backup_dots.clear();
}




void
Paper::
clear()
{
         dots.clear();
  backup_dots.clear();
  dots_buffer.clear();

  std::memset(&pixels,0,sizeof(pixels));
}


namespace{


void
write(const char*  s, std::vector<char>&  v)
{
  auto  len = std::strlen(s);

    if(len >= UINT8_MAX)
    {
      report;
      return;
    }


  putc(len,v);

    while(len--)
    {
      putc(*s++,v);
    }
}


bool
read(const char*  s, std::string::const_iterator&  it)
{
  auto  len = getc(it);

  std::string  buf;

    while(len--)
    {
      buf.push_back(getc(it));
    }


  return(buf == s);
}


}


bool
Paper::
load(const char*  path, Palette&  palette)
{
  auto  gz = load_gzfile(path);

  auto  it = gz.cbegin();

    if(read("dottle",it))
    {
        rep(i,Palette::color_index_number)
        {
          palette.set_color_index(i,getc(it));
        }


      const int  w = getc16le(it);
      const int  h = getc16le(it);

        if((w > size) ||
           (h > size))
        {
          report;
          return false;
        }


        rep(y,size){
        rep(x,size){
          pixels[y][x].data = getc(it);
        }}


      return true;
    }


  return false;
}


bool
Paper::
save(const char*  path, const Palette&  palette) const
{
  std::vector<char>  v;

  write("dottle",v);

    rep(i,Palette::color_index_number)
    {
      putc(palette.get_color_index(i),v);
    }


  putc16le(size,v);
  putc16le(size,v);

    rep(y,size){
    rep(x,size){
      putc(get(x,y).data,v);
    }}


  save_gzfile(v.data(),v.size(),path);

  return true;
}




