#include"paper.hpp"
#include<png.h>
#include<zlib.h>




bool
Paper::
save_as_png(const char*  path, const Palette&  palette) const
{
  FILE*  out = fopen(path,"wb");

    if(!out)
    {
      perror("");

      printf("%s was not saved.\n",path);

      return false;
    }


  png_struct*  png = png_create_write_struct(PNG_LIBPNG_VER_STRING,nullptr,nullptr,nullptr);

  png_info*  png_info = png_create_info_struct(png);

  png_init_io(png,out);

  png_set_compression_level(png,Z_BEST_COMPRESSION);

  auto  buf = (uint8_t*)malloc(3*size*size);

  auto  bufp = buf;

  std::vector<const uint8_t*>  p;

    rep(y,size)
    {
      p.push_back(bufp);

        rep(x,size)
        {
          uint8_t  r;
          uint8_t  g;
          uint8_t  b;

          auto  color = get(x,y).get_lighted_color();

          SDL_GetRGB(color,common_format,&r,&g,&b);

          *bufp++ = r;
          *bufp++ = g;
          *bufp++ = b;
        }
    }


  png_set_IHDR(png,png_info,size,size,8,PNG_COLOR_TYPE_RGB,PNG_FILTER_TYPE_BASE,PNG_COMPRESSION_TYPE_BASE,PNG_INTERLACE_NONE);

  auto  pp = (uint8_t**)p.data();

  png_set_rows(png,png_info,pp);

  png_write_png(png,png_info,PNG_TRANSFORM_IDENTITY,nullptr);

  free(buf);


  png_destroy_write_struct(&png,&png_info);

  fclose(out);

  return true;
}




