#include"paper.hpp"




void
Paper::
store_string()
{
    if(dots.size())
    {
      dots_buffer.emplace_back(std::make_pair(UDO_string,std::move(dots)));

      dots.clear();
    }
}


void
Paper::
store_stroke()
{
    if(dots.size())
    {
      dots_buffer.emplace_back(std::make_pair(UDO_stroke,std::move(dots)));

      dots.clear();
    }
}


void
Paper::
undo()
{
    if(dots.size())
    {
      auto&  dot = dots.back();

      pixels[dot.get_y()][dot.get_x()] = dot.get_pixel();

      dots.pop_back();

      return;
    }


    if(dots_buffer.size())
    {
      auto  tmp = std::move(dots_buffer.back());

      dots_buffer.pop_back();

      dots = std::move(tmp.second);

        if(tmp.first == UDO_string)
        {
          undo();
        }

      else
        if(tmp.first == UDO_stroke)
        {
            while(dots.size())
            {
              auto&  dot = dots.back();

              pixels[dot.get_y()][dot.get_x()] = dot.get_pixel();

              dots.pop_back();
            }
        }
    }
}




