#ifndef _PIXEL_
#define _PIXEL_


#include<cstdint>
#include"jiscolor.hpp"



class Palette;


struct
Pixel
{
  using LightLevel = int;//3bits
  using ColorIndex = int;//4bits


  uint8_t  data;

  constexpr  Pixel(uint8_t  _data=0): data(_data){}
  constexpr  Pixel(int  l, int  c): data((l<<4)|c){}

  constexpr LightLevel  get_light_level() const{return(data>>4);}
  constexpr ColorIndex  get_color_index() const{return(data&15);}

  void   reset_light_level(int  l);
  void   reset_color_index(int  i);

  Color     get_base_color() const;
  Color  get_lighted_color() const;

  bool  operator==(const Pixel&  rhs) const;
  bool  operator!=(const Pixel&  rhs) const;

};


struct
Dot
{
  uint32_t  data;

  constexpr int  get_x() const{return((data>>20)&0xFFF);};
  constexpr int  get_y() const{return((data>> 8)&0xFFF);};

  constexpr Pixel  get_pixel() const{return Pixel(data&0xFF);};

  constexpr Dot(int  x, int  y, uint8_t  pixel): data((x<<20)|(y<<8)|pixel){}

};




#endif




