#include"dottle.hpp"




View::
View()
{
  zoom_value = zoom_min;

  framing_flag = false;

  reset_parameter();
}




int  View::get_pixel_size() const{return pixel_size;}

int  View::get_col_number() const{return col_number;}
int  View::get_row_number() const{return row_number;}


void
View::
set_framing(bool  v)
{
  framing_flag = v;
}


bool
View::
test_framing() const
{
  return framing_flag;
}




void
View::
reset_parameter()
{
  pixel_size = (zoom_value/zoom_min);

  widgets.pad_w = ((size/reduce_value)/(zoom_value/zoom_min));
  widgets.pad_h = ((size/reduce_value)/(zoom_value/zoom_min));

  col_number = (size/pixel_size);
  row_number = (size/pixel_size);

  col_number = ((col_number > Paper::size)? Paper::size:col_number);
  row_number = ((row_number > Paper::size)? Paper::size:row_number);
}


void
View::
set_zoom_value(int  v)
{
  zoom_value = v;

  reset_parameter();

  brush.set_x_offset(0);
  brush.set_y_offset(0);

  brush.fix_x_base();
  brush.fix_y_base();

  widgets.update();
}


void
View::
operate(Paper::FrameFunction  fn)
{
  (paper.*fn)(frame.get_two_points());

  view.widgets.update();
}




