#ifndef DOM_HPP
#define DOM_HPP


#include<cstdint>
#include<cstdio>
#include<cstdlib>
#include<cerrno>
#include<memory>
#include<list>
#include<string>
#include<vector>
#include<unordered_map>


namespace dom{




class Element;


class
ElementMap
{
  Element&  parent;

  std::unordered_map<std::string,Element*>  members;

public:
  ElementMap(Element&  _parent);

  Element&  operator[](const std::string&  name);

};




class
Element
{
  std::unordered_map<std::string,ElementMap*>  children;

public:
  using Attributes = std::unordered_map<std::string,std::string>;

  Element*  const parent;

  const std::string  element_name;

  Element(Element*  _parent=nullptr, const std::string&  name="ROOT");

  ElementMap&  operator[](const std::string&  name);

  Attributes  attributes;

};




}




#endif




