#include"mouse.hpp"
#include"widget.hpp"




namespace oat{


Mouse::
Mouse()
{
  clear();
}




int  Mouse::get_rel_x() const{return rel_x;}
int  Mouse::get_rel_y() const{return rel_y;}
int  Mouse::get_abs_x() const{return abs_x;}
int  Mouse::get_abs_y() const{return abs_y;}


bool
Mouse::
test_enter(const Widget&  wid) const
{
    if((abs_x >=   wid->left) &&
       (abs_y >=    wid->top) &&
       (abs_x <   wid->right) &&
       (abs_y <  wid->bottom))
    {
      return true;
    }


  return false;
}


void
Mouse::
reset_rel(const Widget&  wid)
{
  rel_x = (abs_x-wid->left);
  rel_y = (abs_y-wid->top );
}


bool  Mouse::test_motion() const{return(motion_flag);}


void
Mouse::
button(const SDL_MouseButtonEvent&  evt)
{
  abs_x = evt.x;
  abs_y = evt.y;

  motion_flag = false;

    switch(evt.state)
    {
      case(SDL_PRESSED):
          switch(evt.button)
          {
            case(SDL_BUTTON_LEFT ):  left.press();break;
            case(SDL_BUTTON_RIGHT): right.press();break;
          }
        break;
      case(SDL_RELEASED):
          switch(evt.button)
          {
            case(SDL_BUTTON_LEFT ):  left.unpress();break;
            case(SDL_BUTTON_RIGHT): right.unpress();break;
          }
        break;
    }
}


void
Mouse::
motion(const SDL_MouseMotionEvent&  evt)
{
  abs_x = evt.x;
  abs_y = evt.y;

  motion_flag = true;

    if(evt.state&SDL_BUTTON_LMASK)
    {
      left.press();
    }

  else
    {
      left.unpress();
    }


    if(evt.state&SDL_BUTTON_RMASK)
    {
      right.press();
    }

  else
    {
      right.unpress();
    }
}


void
Mouse::
clear()
{
  rel_x = 0;
  rel_y = 0;
  abs_x = 0;
  abs_y = 0;

  motion_flag = 0;
}


void
Mouse::
print() const
{
  printf("[oat::mouse print] %4d:%4d, REL(%4d:%4d)\n",abs_x,abs_y,rel_x,rel_y);
}




}




