#ifndef OAT_ROOT_HPP
#define OAT_ROOT_HPP


#include"node.hpp"
#include<vector>


namespace oat{




class
Root: public  Node
{
public:
  using Callback = void  (*)(Root&  root, const std::string&  s);

protected:
  SDL_Window*      window;
  SDL_Renderer*  renderer;
  SDL_Texture*    texture;

  Widget*  current_widget;

  Callback  cb;

public:
   Root(const std::string&  _title, int  x, int  y);
  ~Root();


        SDL_Window*  get_window()      ;
  const SDL_Window*  get_window() const;

  Widget&  get_current_widget();

  bool  test_window_id(uint32_t  id);

  bool  operator==(const SDL_Window*  win) const;
  bool  operator!=(const SDL_Window*  win) const;

  void  join_to(Node&  _parent, int  x, int  y){printf("error\n");}

  void  set_callback(Callback  _cb);

  bool  test_callback() const;

  void  do_on_drop(const char*  s);

  void  reenter(Widget&  wid);

  void    draw();
  void  redraw();

  void   update();
  void  refresh();

};


}




#endif




